'--------------------------------------------------------------
' EFYclk.bas 18-10-04
' REAL TIME CLOCK DISPLAY ON six 7-SEG DISPLAYS
' BY k.s.sankar www.mostek.biz for EFY
' written using BASCOM-51 from MSC electronics Netherlands
'--------------------------------------------------------------
'Connect common cathode LED displays as following
:
' port-0 (red)
'a = P0.0
'b = P0.1
'c = P0.2
'd = P0.3
'e = P0.4
'f = P0.5
'g = P0.6
'dp= p0.7
'
'88 88 88
'hh mm ss port-2 (green) p2.0 /1 : 2/3 : 4/5
'12 34 56 digit number
' yellow port-1 set switches
'P1.0=H+ P1.1=H-
'P1.2=M+ P1.3=M-
'P1.4= 00 00 00 ( reset to 00 00 00)
'--------------------------------------------------------------
$regfile = "89s8252.dat"
$crystal = 6000000
'6 mhz crstal
Dim Once_a_sec As Bit
Dim Clock_word As Word
Dim Hours As Byte , Minutes As Byte , Seconds As Byte
Dim Red As Byte , Green As Byte
Dim Count As Byte , X As Byte , Segment As Byte
Dim Number As Byte , Digit_select As Byte
Dim Del As Byte , Diagdelay As Byte
Dim Large As Word
Del = 1
' delay variable in milliseconds
' all ports 0
P0 = 0
'red
P1 = 255
'yellow all high for sw inputs
P2 = 0
'green
P3 = 0
'blue not used
Config Debounce = 30
' key debounce time in milli seconds
Config Timer0 = Timer , Gate = Internal , Mode = 2
'Timer0 use timer 0
'Gate = Internal no external interrupt
'Mode = 2 8 bit auto reload
Gosub Diag
' diagnostic routine
' set t0 internal interrupt
On Timer0 Timer_0_int
Load Timer0 , 250
Priority Set Timer0
Enable Interrupts
Enable Timer0
Start Timer0
Hours = 0
Minutes = 0
Seconds = 0
Clock_word = 0
Do
' yellow port-1 key inputs for setting
Debounce P1.0 , 0 , Hup , Sub
Debounce P1.1 , 0 , Hdown , Sub
Debounce P1.2 , 0 , Mup , Sub
Debounce P1.3 , 0 , Mdown , Sub
Debounce P1.4 , 0 , Zero , Sub
If Once_a_sec = 1 Then
' once_a_sec=calculation every second
Once_a_sec = 0
'update hh mm ss
inc seconds
If Seconds = 60 Then
Seconds = 0
inc minutes
If Minutes = 60 Then
Minutes = 0
inc hours
If Hours = 24 Then
Hours = 0
End If
End If
End If
End If
' display time constantly
' hours
Number = Hours / 10
P2 = 1
Gosub Disp
Waitms Del
P0 = 0
'-------
Number = Hours Mod 10
P2 = 2
Gosub Disp
Waitms Del
P0 = 0
'-------
'minutes
Number = Minutes / 10
P2 = 4
Gosub Disp
Waitms Del
P0 = 0
'-------
Number = Minutes Mod 10
P2 = 8
Gosub Disp
Waitms Del
P0 = 0
'-------
'SECONDS
Number = Seconds / 10
P2 = 16
Gosub Disp
Waitms Del
P0 = 0
'-------
Number = Seconds Mod 10
P2 = 32
Gosub Disp
Waitms Del
P0 = 0
'-------
Loop
' - - - - - - - - - - - - - - - - - -
' set keys below
Hup:
Incr Hours
If Hours >= 24 Then
Hours = 0
End If
Return
Hdown:
Decr Hours
If Hours = 255 Then
Hours = 23
End If
Return
Mup:
Incr Minutes
If Minutes >= 60 Then
Minutes = 0
End If
Return
Mdown:
Decr Minutes
If Minutes = 255 Then
Minutes = 59
End If
Return
Zero:
Hours = 0 : Minutes = 0 : Seconds = 0
Return
' - - - - - - - - -- - - - - - - -- - - - - -

Diag:
'diagnostics
'if zero button pressed then goto zero label and return
Diagdelay = 121
For Seconds = 1 To 5
Diagdelay = Diagdelay - 20
P2 = 1
For Green = 0 To 5
P0 = 1
For Red = 0 To 7
Debounce P1.4 , 0 , Zero
Waitms Diagdelay
Rotate P0 , Left
Next Red
Rotate P2 , Left
Next Green
Next Seconds
' next diag show 000000 to 999999 on all digits
' - - - - - - - -- - - - - -- - - - - - - -- - - -
'For Number = 0 To 9
'P2 = 1
'For Large = 1 To 50
' approx 1 second time loop with 200 in large
'For Green = 0 To 5
'Debounce P1.4 , 0 , Zero
'Gosub Disp
'Waitms Del
'Rotate P2 , Left
'Next Green
'Next Large
'Next Number
'Return

'Displaying routine
Disp:
Restore Tabela
' scan 7-seg table to get byte for the digit to display
For X = 0 To 9
Read Segment
If X = Number Then
'if X = value to display
P0 = Segment
'then set this value to Port0-red
Exit For
'and exit FOR loop
End If
Next
Return

' int subroutine -----------------
Timer_0_int:
Incr Clock_word
If Clock_word > 2000 Then
Clock_word = 0
Once_a_sec = 1
End If
Return
'---- data for 7-seg LED display ------
Tabela:
Data 63 , 6 , 91 , 79 , 102 , 109 , 125 , 7 , 127 , 111
' end of program
' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=